/// <reference path="typings/toastr/toastr.d.ts" />
/// <reference path="typings/jqueryui/jqueryui.d.ts" />
/// <reference path="typings/jquery/jquery.d.ts" />
/// <reference path="typings/requirejs/require.d.ts" />
"use strict";
define(["require", "exports"], function(require, exports) {
    exports._dummyExport = undefined;

    $(document).ready(function () {
        function deHilightAllHilightedElements() {
            $(".content div.DisplayIdClass").removeAttr('title');
            $(".content div.DisplayIdClass").removeClass('outline-element');
        }

        function hilightActiveElement(event) {
            console.log("hilightActiveElement");
            var activeElem = $(event.target).closest('.DisplayIdClass');
            if (activeElem != null) {
                deHilightAllHilightedElements();
                var activeElemId = activeElem.attr('displayIdAttr');

                //Add tool tip
                if (activeElemId != null) {
                    activeElem.attr('title', "ID: " + activeElemId);
                }

                //hilight the border of the activeElem
                activeElem.addClass('outline-element');

                //display the id in status bar
                $('.right .statusbar .displayIdDiv').html("ID: " + activeElemId);
            }
        }

        function toggleDisplayId() {
            deHilightAllHilightedElements();
            $(".content .displayId").toggle();

            $(".content").toggleClass('ProgramAnnDisplayIdClass DisplayIdClass');

            //Do not display formula display ids when the node is a program node.
            $(".content .Invariant").not(".content .ProgramAnn .Invariant").toggleClass('InvariantDisplayIdClass DisplayIdClass');

            $(".content .Pred").not(".content .ProgramAnn .Pred").toggleClass('PredDisplayIdClass DisplayIdClass');

            $(".content .Var").not(".content .ProgramAnn .Var").toggleClass('VarDisplayIdClass TermDisplayIdClass DisplayIdClass');
            $(".content .Const").not(".content .ProgramAnn .Const").toggleClass('ConstDisplayIdClass TermDisplayIdClass DisplayIdClass');
            $(".content .ArrSelect").not(".content .ProgramAnn .ArrSelect").toggleClass('ArrSelectDisplayIdClass TermDisplayIdClass DisplayIdClass');
            $(".content .ArrStore").not(".content .ProgramAnn .ArrStore").toggleClass('ArrStoreDisplayIdClass TermDisplayIdClass DisplayIdClass');
            $(".content .QTerm").not(".content .ProgramAnn .QTerm").toggleClass('QTermDisplayIdClass TermDisplayIdClass DisplayIdClass');
            $(".content .FnApp").not(".content .ProgramAnn .FnApp").toggleClass('FnAppDisplayIdClass TermDisplayIdClass DisplayIdClass');

            $(".content .True1").not(".content .ProgramAnn .True1").toggleClass('True1DisplayIdClass  FormulaDisplayIdClass DisplayIdClass');
            $(".content .False1").not(".content .ProgramAnn .False1").toggleClass('False1DisplayIdClass FormulaDisplayIdClass DisplayIdClass');
            $(".content .Not").not(".content .ProgramAnn .Not").toggleClass('NotDisplayIdClass FormulaDisplayIdClass DisplayIdClass');
            $(".content .And").not(".content .ProgramAnn .And").toggleClass('AndDisplayIdClass FormulaDisplayIdClass DisplayIdClass');
            $(".content .Or").not(".content .ProgramAnn .Or").toggleClass('OrDisplayIdClass FormulaDisplayIdClass DisplayIdClass');
            $(".content .Impl").not(".content .ProgramAnn .Impl").toggleClass('ImplDisplayIdClass FormulaDisplayIdClass DisplayIdClass');
            $(".content .Iff").not(".content .ProgramAnn .Iff").toggleClass('IffDisplayIdClass FormulaDisplayIdClass DisplayIdClass');
            $(".content .Forall").not(".content .ProgramAnn .Forall").toggleClass('ForallDisplayIdClass FormulaDisplayIdClass DisplayIdClass');
            $(".content .Exists").not(".content .ProgramAnn .Exists").toggleClass('ExistsDisplayIdClass FormulaDisplayIdClass DisplayIdClass');
            $(".content .Unknown").not(".content .ProgramAnn .Unknown").toggleClass('UnknownDisplayIdClass FormulaDisplayIdClass DisplayIdClass');

            $('.right .statusbar .displayIdDiv').html('');
        }

        function toggleDisplayIdAndGoToBottom() {
            toggleDisplayId();

            //Go to bottom of the div
            $('.right').scrollTop($('.right')[0].scrollHeight);
        }

        function selectClickedElement(event) {
            // Get the outlined element
            console.log("in mousedown");
            var activeElem = $(this).find('.outline-element');

            // Get the id
            var activeElemId = activeElem.attr('displayIdAttr');
            console.log(activeElemId);
            if (activeElemId != null) {
                console.log("selected element " + activeElemId);
                toggleDisplayIdAndGoToBottom();
            }
        }

        function toggleDbg() {
            //a utility function to hide the debug elements.
            console.log("toggleDbg called");
            if (toggleDbg.show == undefined) {
                toggleDbg.show = true;
            } else {
                toggleDbg.show = !toggleDbg.show;
            }

            if (toggleDbg.show == true) {
                $(".ProgramAnn .id").show();

                //$(".posummary").show(); //TODO: enable these lines
                //$(".nodeObjDbg").show();
                //$(".pa_proofobligs").show();
                //$(".top").show();
                $(".statusbar").show();
            } else {
                $(".ProgramAnn .id").hide();

                //$(".posummary").hide(); //TODO: enable these lines
                //$(".nodeObjDbg").hide();
                //$(".pa_proofobligs").hide();
                //$(".top").hide();
                $(".statusbar").hide();
            }
        }

        function main() {
            $("#toggleIdBtn.topButton").click(toggleDisplayIdAndGoToBottom);

            //Keyboard shortcut for displaying the id  and going to bottom of the page.
            $(document).bind('keydown', 'ctrl+F7', toggleDisplayIdAndGoToBottom);

            $(".content").on({
                mouseover: hilightActiveElement
            });

            $(".content").on({
                mousedown: selectClickedElement
            });
            // For some reason can not call it directly from console, hence binding to Ctrl+F9
            // Update: Disabled toggleDbg
            //$(document).bind('keydown', 'ctrl+F9', toggleDbg);
        }

        //Call main
        main();
    });
});
//# sourceMappingURL=toggleId.js.map
